/******************************************************************************
	  CCCC	    A	  BBBBB	  L	EEEEE  N     N	EEEEE	TTTTTTT
	 C    C    A A	  B    B  L	E      NN    N	E	   T
	C	  A   A	  B    B  L	E      N N   N	E	   T
	C	 AAAAAAA  BBBBB	  L	EEEEE  N  N  N	EEEEE	   T
	C        A     A  B    B  L	E      N   N N	E	   T
	 C    C  A     A  B    B  L	E      N    NN  E 	   T
	  CCCC	 A     A  BBBBB	  LLLL	EEEEE  N     N	EEEEE	   T
*******************************************************************************

CableNet Source Module:
	Copyright 1994-1995 (C) CableNet Limited. All Rights Reserved.

    Module Name:		$RCSfile: dflts.h,v $
    Module Description:	defaults library header file


Description: 


Edit History:

	$Log: dflts.h,v $
 * Revision 1.1  1997/08/20  10:50:31  damian
 * Initial revision
 *

*/

/* RCS identification string (for "what" program) 
static char moduleRCSid[] = "@(#) $Id: dflts.h,v 1.1 1997/08/20 10:50:31 damian Exp $";
*/


#ifndef _DFLTS_H
#define _DFLTS_H

#include <stdio.h>

#include "Vllist.h"

extern char *Vprogram;

#ifdef Vsunos40
#include "Vansi.h"
#endif




#define     ANY_DFLT_SET        0
#define     GLOBAL_DFLT_SET     1
#define     LOCAL_DFLT_SET      2
#define     USER_DFLT_SET       3

typedef struct DfltsInfo {
    char    *set;
    char    *group;
    char    *tag;
    char    *val;
    int     num;
    int     base;
} DfltsInfo;

#ifdef VANSI_1
extern int DfltsInit(char *, char *, char *);
extern int DfltSetBaseSet( DfltsInfo *di );
extern char  *DfltGetBaseSet( int);
extern char *DfltGetCurrentSet(int);
extern char *DfltGetCurrentGroup(int);
extern int DfltSetCurrentGroup( DfltsInfo *di );
extern int DfltSetCurrentSet( DfltsInfo *di );
extern int DfltSetString( DfltsInfo *di );
extern char *DfltGetString( DfltsInfo *di );
extern int DfltSetInt( DfltsInfo *di );
extern int DfltGetInt( DfltsInfo *di );
extern char *DfltGetSet( DfltsInfo *di );
extern int DfltGetBool( DfltsInfo *di );
extern char *DfltGetGroup( DfltsInfo *di );
extern int DfltDeleteGroup(char *path);
#else
extern int DfltSetBaseSet();
extern char *DfltGetBaseSet();
extern int DfltsInit();
extern char *DfltGetCurrentSet();
extern char *DfltGetCurrentGroup();
extern int DfltSetCurrentGroup();
extern int DfltSetCurrentSet();
extern int DfltSetString();
extern char *DfltGetString();
extern int DfltSetInt();
extern int DfltGetInt();
extern char *DfltGetSet();
extern int DfltGetBool();
extern char *DfltGetGroup();
extern int DfltDeleteGroup();
#endif


#endif  /* _DFLTS_H_ */

